<?xml version="1.0" encoding="UTF-8"?>
<jube>
  <include-path>
  <path tag="jureca">../platforms/JURECA</path>
  <path tag="jureca_boo">../platforms/JURECA_BOOSTER</path>
  <path tag="claix">../platforms/CLAIX</path>
  <path tag="claix2018">../platforms/CLAIX2018</path>
  <path tag="claix_knl">../platforms/CLAIX_KNL</path>
  <path tag="hazelhen">../platforms/HAZELHEN</path>
  <path tag="supermuc">../platforms/SUPERMUC</path>
  <path tag="supermucng">../platforms/SUPERMUCNG</path>
  </include-path>

  <benchmark name="FLEUR_MnGe_4x4x8" outpath="FLEUR_bench">
    <comment>FLEUR MnGe 4x4x8 benchmark</comment>
    
    <!-- Job configuration -->
    <parameterset name="systemParameter" init_with="job_config.xml"> 
    </parameterset>

    <!-- Job submission -->
    <parameterset name="executeset" init_with="platform.xml">
    </parameterset>

    <!-- Load files -->
    <fileset name="jobfiles" init_with="platform.xml">
      <copy>input_files/inp.xml</copy>
      <copy>input_files/kpts.xml</copy>
      <copy>input_files/sym.xml</copy>
    </fileset>

    <!-- Substitute jobfile -->
    <substituteset name="executesub" init_with="platform.xml">
    </substituteset>

    <!-- Operation -->
    <step name="submit">
      <use>systemParameter</use> 
      <use>executeset</use>
      <use>jobfiles,executesub</use> 
      <do done_file="$ready_file">$submit $submit_script</do> 
      <do>rm -f broyd* pot* cdn* wkf2 stars mix*</do> 
      <do> tail -150 out > juDFT_times </do>
    </step>

    <!-- Extract time of execution -->
    <patternset name="metrics_time" >
       <pattern name="wtime_tot" type="float">0 $jube_pat_bl Total Run $jube_pat_bl ${jube_pat_fp}sec</pattern>
       <pattern name="wtime_init" type="float">Initialization $jube_pat_bl ${jube_pat_fp}sec</pattern>
       <pattern name="wtime_stden" type="float">generation of start-density $jube_pat_bl ${jube_pat_fp}sec</pattern>
       <pattern name="wtime_iter" type="float">Iteration $jube_pat_bl ${jube_pat_fp}sec</pattern>
       <pattern name="wtime_vgen" type="float">generation of potential $jube_pat_bl ${jube_pat_fp}sec</pattern>
       <pattern name="wtime_eigen" type="float">3  eigen $jube_pat_bl ${jube_pat_fp}sec</pattern>
       <pattern name="wtime_upd" type="float">4 Updating energy parameters $jube_pat_bl ${jube_pat_fp}sec</pattern>
       <pattern name="wtime_MT" type="float">5 MT part $jube_pat_bl ${jube_pat_fp}sec</pattern>
       <pattern name="wtime_sph" type="float">6 spherical setup $jube_pat_bl ${jube_pat_fp}sec</pattern>
       <pattern name="wtime_nsph" type="float">6 non-spherical setup $jube_pat_bl ${jube_pat_fp}sec</pattern>
       <pattern name="wtime_LO" type="float">6 LO setup $jube_pat_bl ${jube_pat_fp}sec</pattern>
       <pattern name="wtime_MatRedis" type="float">5 Matrix redistribution $jube_pat_bl ${jube_pat_fp}sec</pattern>    
       <pattern name="wtime_diag" type="float">Diagonalization $jube_pat_bl ${jube_pat_fp}sec</pattern>
       <pattern name="wtime_char" type="float">generation of new charge densi $jube_pat_bl ${jube_pat_fp}sec</pattern>
       <pattern name="wtime_mix" type="float">2   Charge Density Mixing $jube_pat_bl ${jube_pat_fp}sec</pattern>
    </patternset>

    <analyser name="analyse">
       <analyse step="submit">
          <file use="metrics_time">juDFT_times</file>
       </analyse>
    </analyser>

    <result>
       <use>analyse</use>
       <table name="timing" style="pretty" sort="number">
          <column>nodes</column>
          <column>taskspernode</column>
          <!--<column>threadspertask</column>-->
          <column>wtime_tot</column>
          <!--<column>wtime_init</column>-->
          <!--<column>wtime_stden</column>-->
          <column>wtime_iter</column>
          <column>wtime_vgen</column>
          <column>wtime_eigen</column>
          <column>wtime_upd</column>
          <column>wtime_MT</column>
          <column>wtime_sph</column>
          <column>wtime_nsph</column>
          <column>wtime_LO</column>
          <column>wtime_MatRedis</column>
          <column>wtime_diag</column>
          <column>wtime_char</column>
          <column>wtime_mix</column>
       </table>
    </result>

  </benchmark>
</jube>
